//  Playstation Input Machine  Test Program  by kako

#include <windows.h>
#include <stdio.h>
#include <conio.h>

#include "rs232.h"
#include "comchk.h"


int main()
{
	unsigned char c=0,c_=0,d,e;
	unsigned char buf[80]; 
	unsigned char data1,data2,data3;
	int i;
	int n;
	int pt;
	int type=0;
	int myport;
	int baud;
	int PortNum;
	int BaudNum;
	char buf1[255],buf2[255],buf3[255];
	
	
	printf("Playstation Input Machine(PIM) Test program.\n");
	printf("\n");
	
	port_device_scan();
	port_device_pickup_all(); // all COM ports
	
	n = get_how_many_port_devices();
	
	printf("--- COM port list ---\n");
	for (i=0;i<n;i++) {
		
		pt = get_port_number(i);
		get_port_name( i , buf1 );
		get_port_device_name( i , buf2 );
		get_port_device_name2( i , buf3 );
		printf("COM%d:\t", pt );
		printf("[%s], ", buf1 );
		printf("[%s], ", buf2 );
		printf("[%s]\n", buf3 );
	}
	printf("------\n");
	
	port_device_scan();
	port_device_pickup_by_type(2); // FTDI
	//port_device_pickup_by_type(1); // built-in COM port
	//port_device_pickup_by_type(2); // FTDI
	//port_device_pickup_by_type(3); // SiLabs CP210x,etc
	//port_device_pickup_by_type(4); // Prolific PL230x,etc
	//port_device_pickup_by_type(5); // Cyress EZ-USB HID-COM
	//port_device_pickup_by_type(6); // ArkMicro
	//port_device_pickup("Vid_0461&Pid_0033"); // search by keyword
	n = get_how_many_port_devices();
	if (n==0) {
		printf("Error: Playstation Input Machine NOT found.\n"); getchar();
		exit(1);
	}
	if (n>0) { PortNum = get_port_number(0); }
	BaudNum=57600;
	
	printf("Open COM Port=%d , Baud=%d\n",PortNum,BaudNum);
	
	myport=PortNum;
	baud=BaudNum;
	i=rs_open(myport,baud);
	if (i==-1) {
		printf("Error: COM%i port cannot open. (already used?)\n",myport); getchar();
		exit(1);
	}
	
	printf("PIM Key Input started. (ESC key to quit.)\n");
	
	while (1) {
		if (rs_size(myport)) {
			c_=c;
			c=rs_getch(myport);
			if ( (c<2)||((c>3)&&(c<8))||((c>13)&&(c<32)) ) {
				/* printf("(%d)",c); fflush(stdout); */
				continue;
			} else {
				if (c==0x0d) { printf("\n"); continue; }
				if (c==0x0a) {
					if (c_!=0x0d) { printf("\n"); continue; } else { continue; }
				}
				printf("%c",c); fflush(stdout);
				continue;
			}
		}
		data1=0; data2=0; data3=0;
		if (kbhit()) {
			d=getch(); e=0;
			if (d==0x1B) { break; }
			if (d==0xE0) { e=getch(); }
			if ((d=='8')||(e==0x48))	{ data1 |= 0x01; } // up
			if ((d=='2')||(e==0x50))	{ data1 |= 0x02; } // down
			if ((d=='4')||(e==0x4B))	{ data1 |= 0x04; } // left
			if ((d=='6')||(e==0x4D))	{ data1 |= 0x08; } // right
			if (d=='d')					{ data2 |= 0x01; } // o
			if ((d=='s')||(d=='x'))		{ data2 |= 0x02; } // x
			if (d=='w')					{ data2 |= 0x04; } // triangle
			if (d=='a')					{ data2 |= 0x08; } // square
			if (d==0x0d)				{ data3 |= 0x01; } // start
			if (d==' ')					{ data3 |= 0x02; } // select
			if (d=='q')					{ data3 |= 0x04; } // L-trigger
			if (d=='e')					{ data3 |= 0x08; } // R-trigger
		}
		rs_putch(myport,data1+0x30);
		rs_putch(myport,data2+0x41);
		rs_putch(myport,data3+0x61);
		rs_putch(myport,0x0d);
		if ((data1!=0)||(data2!=0)||(data3!=0)) {
			printf("key=<%02x,%02x> : ",d,e); printf("[%c%c%c]\n",data1+0x30,data2+0x41,data3+0x61);
		}
		Sleep(16); // 1/60 sec.
	}
	
	printf("Quit.\n");
	
	rs_close(myport);
	
    return 0;
}
